// ConsoleApplication1.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include<stdio.h>
#include <cstdlib>
#include <iostream>

void swap(int* p1, int* p2);


int partition(int arr[], int l, int r)
{
	int x = arr[r];    
	int i = (l - 1);  

	for (int j = l; j <= r - 1; j++)
	{
		if (arr[j] <= x)
		{
			i++;    
			swap(&arr[i], &arr[j]);  
		}
	}
	swap(&arr[i + 1], &arr[r]);
	return (i + 1);
}

void QuickSort(int arr[], int l, int r)
{
	if (l < r)
	{
		int p = partition(arr, l, r); 
		QuickSort(arr, l, p - 1);
		QuickSort(arr, p + 1, r);
	}
}


void PrintArray(int arr[], int size)
{
	int i;
	for (i = 0; i < size; i++)
		std::cout << arr[i] << "  ";
}


int main()
{
	int arr[] = { 12,3,10,2,6,8,7 };
	int n = sizeof(arr) / sizeof(arr[0]);
	printf("old array is:\n");
	PrintArray(arr,n);
	QuickSort(arr, 0, n - 1);
	printf("Sorted array: \n");
	PrintArray(arr, n);
	system("pause");
}

void swap(int* p1, int* p2)
{
	int temp;
	temp = *p1;
	*p1 = *p2;
	*p2 = temp;
}